;80 B2 00 00 0x 60 [RSA_data_in_96]		;RSA public / private exponentiation
;80 B2 00 00 0x [RCH] [RCL] 60 [RSA_data_out_96]
;x is { 0 => public RSA, 1 => private RSA }

;------------------------------------------------------------------------------

	ldd	r16,z+3
	tst	r16
	m_brne_err3			;incorrect parameters REF1, REF2

	ldd	r16,z+4
	mov	r17,r16			;store here
	andi	r16,$FE			;least significant bit is { 0, 1 }
	m_brne_err3			;incorrect parameters REF1, REF2

	ldd	r16,z+5
	cpi	r16,_RSA_768_length
	m_brne_err4			;incorrect size LEN

;------------------------------------------------------------------------------

	ldi	zl,low(EE_mod)
	ldi	zh,high(EE_mod)

	andi	zh,$1F			;8192 bytes eeprom
	ori	zh,$80			;eeprom is $8000-$9FFF

	ldi	r16,_sc_RSA_modulus	;load modulus
	sts	RAM_system_call,r16
	ldi	r16,_RSA_768_length
	wdr				;system call

	sts	RAM_RC_high,r16
	cpi	r16,_EC_RSA_success	;check success
	m_brne_err6			;RSA error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
	ldi	zl,low(RAM_buf)		;start address for data in RAM
	ldi	zh,high(RAM_buf)
	adiw	zl,6

	ldi	r16,_sc_RSA_data_in	;set RSA data
	sts	RAM_system_call,r16
	ldi	r16,_RSA_768_length
	wdr				;system call
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
	ldi	zl,low(EE_pub)		;public exponent
	ldi	zh,high(EE_pub)
	tst	r17
	breq	_rsa1
	ldi	zl,low(EE_prv)		;private exponent
	ldi	zh,high(EE_prv)

_rsa1:	andi	zh,$1F			;8192 bytes eeprom
	ori	zh,$80			;eeprom is $8000-$9FFF

	ldi	r16,_sc_RSA_exponent	;set exponent and exponentiate
	sts	RAM_system_call,r16
	ldi	r16,_RSA_768_length
	wdr				;system call

	sts	RAM_RC_high,r16
	cpi	r16,_EC_RSA_success	;check success
	m_brne_err6			;RSA error
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~;
	ldi	zl,low(RAM_buf)		;start address for data in RAM
	ldi	zh,high(RAM_buf)
	adiw	zl,8

	ldi	r16,_sc_RSA_data_out	;get RSA data
	sts	RAM_system_call,r16
	ldi	r16,_RSA_768_length
	wdr				;system call

;------------------------------------------------------------------------------

	ldi	r16,_RSA_768_length	;answer LEN
	jmp	_suc1			;command executed properly
