;============================================================
;= Copyright  2001 Tayfun Gms                            =
;= Source code is free for use with MAMP-OS smart card only =
;= All other usage is prohibited                            =
;= T=E Protocol example user source code for MAMP-OS V1.0   =
;= Set tabulator size to 9                                  =
;============================================================

.nolist
.include	"v10_32c.inc"
.include	"macro.asm"

.cseg
.org 0					;mandatory

reset:
.include	"init.asm"			;set protocol parameters
.include	"atr.asm"			;send out answer to reset

;------------------------------------------------------------------------------

start:	ldi	yl,low(RAM_port)		;clear user RAM including AES key
	ldi	yh,high(RAM_port)
	clr	r16
_crm1:	st	-y,r16
	tst	yl
	brne	_crm1

	ldi	r16,_sc_rx_T_E		;receive request in T=E protocol
	sts	RAM_system_call,r16
	wdr				;system call
	breq	_rok0			;Z flag set if correct checksum 
	rjmp	_err5			;checksum verification failed

_rok0:	ldi	zl,low(RAM_buf)
	ldi	zh,high(RAM_buf)

	ldd	r16,z+1			;get CLA
	cpi	r16,$70
	breq	c_70_
	cpi	r16,$B2
	breq	c_B2_
	cpi	r16,$B3
	breq	c_B3_
	rjmp	_err1			;undefined class

c_70_:	rjmp	CLA_70			;example class
c_B2_:	rjmp	CLA_B2			;crypto related commands
c_B3_:	rjmp	CLA_B3			;PIN related commands

;------------------------------------------------------------------------------

CLA_70:	ldd	r16,z+2			;get INS
	cpi	r16,$00
	breq	i_70_00
	rjmp	_err2			;undefined instruction

i_70_00:	rjmp	_i_70_00			;empty example function

_i_70_00:
.include	"CLA_70\INS_00.asm"

;------------------------------------------------------------------------------

CLA_B2:	ldd	r16,z+2			;get INS
	cpi	r16,$00
	breq	i_B2_00
	cpi	r16,$10
	breq	i_B2_10
	cpi	r16,$20
	breq	i_B2_20
	rjmp	_err2			;undefined instruction

i_B2_00:	rjmp	_i_B2_00			;RSA
i_B2_10:	rjmp	_i_B2_10			;AES
i_B2_20:	rjmp	_i_B2_20			;random number

_i_B2_00:
.include	"CLA_B2\INS_00.asm"
_i_B2_10:
.include	"CLA_B2\INS_10.asm"
_i_B2_20:
.include	"CLA_B2\INS_20.asm"

;------------------------------------------------------------------------------

CLA_B3:	ldd	r16,z+2			;get INS
	cpi	r16,$1E
	breq	i_B3_1E
	cpi	r16,$AA
	breq	i_B3_AA
	rjmp	_err2			;undefined instruction

i_B3_1E:	rjmp	_i_B3_1E			;change PIN
i_B3_AA:	rjmp	_i_B3_AA			;enter user code upload mode upon valid PIN

_i_B3_1E:
.include	"CLA_B3\INS_1E.asm"
_i_B3_AA:
.include	"CLA_B3\INS_AA.asm"

;------------------------------------------------------------------------------

_err0:	clr	r16			;LEN = 0
_suc0:	ldi	zl,low(RAM_buf)
	ldi	zh,high(RAM_buf)
	std	z+7,r16			;LEN

	lds	r16,RAM_RC_high
	std	z+5,r16
	lds	r16,RAM_RC_low
	std	z+6,r16

	ldi	r16,_sc_tx_T_E		;transmit answer in T=E protocol
	sts	RAM_system_call,r16
	wdr				;system call

;------------------------------------------------------------------------------

	rjmp	start

.include	"rc.asm"				;return codes

;------------------------------------------------------------------------------

.org $1FFF				;last code word location
	nop

;------------------------------------------------------------------------------

.include	"eeprom.asm"			;user EEPROM

.exit
