//----------------------------------------------------------------------------
// MAMP-OS Terminal is a part of MAMP-OS SDK and written by Tayfun Gumus
// Source code is given free to push MAMP-OS smart card applications and tools
// Everybody is welcome to contribute his / her part
//----------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "mampos_unit1.h"

HANDLE hComm = NULL,
       hFile = NULL;
COMMTIMEOUTS ctmoNew = {0}, ctmoOld;

int card, memo = M_NEW, memopos;
unsigned long len, rlen;
AnsiString s;

byte r[256];	//response
byte r1[256];
byte command[256];


//RSA 768 bit public and private exponentiation
byte c_x10[] = {0x80,0xB2,0x00,0x00,0x00,0x60,0x80,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x10,0x11,0x12,0x13,0x14,0x15,0x16,0x17,0x20,0x21,0x22,0x23,0x24,0x25,0x26,0x27,0x30,0x31,0x32,0x33,0x34,0x35,0x36,0x37,0x40,0x41,0x42,0x43,0x44,0x45,0x46,0x47,0x50,0x51,0x52,0x53,0x54,0x55,0x56,0x57,0x60,0x61,0x62,0x63,0x64,0x65,0x66,0x67,0x70,0x71,0x72,0x73,0x74,0x75,0x76,0x77,0x80,0x81,0x82,0x83,0x84,0x85,0x86,0x87,0x90,0x91,0x92,0x93,0x94,0x95,0x96,0x97,0xA0,0xA1,0xA2,0xA3,0xA4,0xA5,0xA6,0xA7,0xB0,0xB1,0xB2,0xB3,0xB4,0xB5,0xB6,0xB7,0};
byte c_x11[] = {0x80,0xB2,0x00,0x00,0x01,0x60,0x74,0x62,0x88,0x8A,0x97,0xB6,0x6F,0x10,0x1F,0x19,0x37,0x7B,0x5C,0x23,0x3E,0x5D,0xC3,0x9D,0x7A,0x45,0x59,0x7E,0x5F,0xC5,0x0D,0x96,0xBC,0xEC,0x93,0x2B,0x4D,0x86,0x8A,0xA0,0x86,0x4F,0x43,0x67,0xB9,0x7E,0x0F,0x74,0x76,0xA6,0x0E,0x14,0xF3,0x3C,0x80,0x40,0xEB,0xF7,0xAB,0x9C,0xE0,0xAF,0x81,0xB4,0xD5,0x9E,0xAC,0x32,0x4C,0xD6,0x04,0x1D,0x01,0x60,0xAE,0x69,0xF6,0x22,0xE9,0x93,0x0C,0xF9,0xA9,0x6A,0x31,0x44,0x53,0x55,0xB8,0x59,0x0B,0xAE,0x51,0x8D,0xDB,0xF9,0x83,0xFE,0x4D,0x29,0x8A,0xF7,0};

//AES encryption data & key
byte c_x12[] = {0x80,0xB2,0x10,0x00,0x00,0x20,0x00,0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99,0xAA,0xBB,0xCC,0xDD,0xEE,0xFF,0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0};
//result is 69 C4 E0 D8 6A 7B 04 30 D8 CD B7 80 70 B4 C5 5A

//random numbers
byte c_x13[] = {0x80,0xB2,0x20,0x00,0x00,0x00,0};
byte c_x14[] = {0x80,0xB2,0x20,0x00,0x00,0x00,0};
byte c_x15[] = {0x80,0xB2,0x20,0x00,0x00,0x00,0};


//PIN used in user source code is: 12345678

//change PIN old -> new
byte c_x16[] = {0x80,0xB3,0x1E,0x00,0x00,0x08,0x12,0x34,0x56,0x78,0x11,0x11,0x11,0x11,0};

//leave user code (application mode) and enter MAMP-OS upload mode upon valid PIN
byte c_x17[] = {0x80,0xB3,0xAA,0x00,0x00,0x04,0x15,0x61,0x71,0x18,0}; //wrong
byte c_x18[] = {0x80,0xB3,0xAA,0x00,0x00,0x04,0x11,0x11,0x11,0x11,0}; //correct

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  PurgeComm(hComm, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
  SetCommTimeouts(hComm, &ctmoOld);
  CloseHandle(hComm);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  AnsiString s1, s2;
  int rc;

  Button1->Enabled = false;
  rc = reset();
  Button1->Enabled = true;

  if (rc == 1)
  {
    Button2->Enabled = true;
    Button3->Enabled = true;
    Button4->Enabled = true;

    if (rc == 0)    //answer received
    {
    }
//    else Form1->Memo1->Lines->Add("no response");
  }
}
//---------------------------------------------------------------------------
int __fastcall TForm1::reset(void)
{
  unsigned int i, rc = 0;

  EscapeCommFunction(hComm, SETRTS);  //reset
  Sleep(200);
  PurgeComm(hComm, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
  EscapeCommFunction(hComm, CLRRTS);  //normal

  for (i = 0; i < MAX_ERASE; i++) r[i] = 0;

  len = 33;
  ReadFile(hComm, r, len, &rlen, NULL);   //ATR
  if (rlen != 0) rc = 1;

  for (i = 0, s = "<-- "; i < rlen; i++) s += (AnsiString::IntToHex(r[i], 2) + " ");
  Form1->Memo1->Lines->Add(s);

  if (rc == 0)
  {
  Button2->Enabled = false;
  Button3->Enabled = false;
  Button4->Enabled = false;
  }

  return(rc);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::transmit_T_E(byte *cmd)
{
  unsigned int i, rc = 0;
  byte chk = 0xff;

  for (i = 0; i < MAX_ERASE; i++) r[i] = 0;

  len = cmd[5] + 6;
  for (i = 0; i < len; i++) chk ^= cmd[i];
  cmd[len] = chk;

  len++;
  for (i = 0, s = "--> "; i < len; i++)
  {
    while (TransmitCommChar(hComm, cmd[i]) == 0);
    s += (AnsiString::IntToHex(cmd[i], 2) + " ");
    Sleep(3);
  }

  Sleep(50);

  ReadFile(hComm, r, len, &rlen, NULL);
  if (rlen != len) rc = 1;

  if (rc == 0)
  {
    switch (memo)
    {
      case M_NEW:
      {
        memopos = Form1->Memo1->Lines->Count;
        Form1->Memo1->Lines->Add(s);
        break;
      }
      case M_SAME:
      {
        while (Form1->Memo1->Lines->Count != memopos)
        {
          Form1->Memo1->Lines->Delete(memopos);
        }
        Form1->Memo1->Lines->Add(s);
        break;
      }
    }
  }

  return(rc);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::receive_T_E(void)
{
  unsigned int i, rc = 0;

  for (i = 0; i < MAX_ERASE; i++) r[i] = 0;

  len = 8;
  ReadFile(hComm, r, len, &rlen, NULL);
  if (rlen != len) rc = 1;

  if (rc == 0) len = r[7] + 1; else len = 0;
  ReadFile(hComm, r + 8, len, &rlen, NULL);
  if (rlen != len) rc = 2;

  len += 8;
  for (i = 0, s = "<-- "; i < len; i++) s += (AnsiString::IntToHex(r[i], 2) + " ");

  if (rc == 0)
  {
    switch (memo)
    {
      case M_NEW:
      {
        Form1->Memo1->Lines->Add(s);
        break;
      }
    }
  }

  return(rc);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::COM_Port(TObject *Sender)
{
  DCB dcbCommPort;

  if (ComboBox3->ItemIndex == -1) ComboBox3->ItemIndex = 1;    //9600
  if (ComboBox2->ItemIndex == -1) ComboBox2->ItemIndex = 0;    //COM1

  if (hComm != NULL)
  {
    PurgeComm(hComm, PURGE_TXABORT | PURGE_RXABORT | PURGE_TXCLEAR | PURGE_RXCLEAR);
    SetCommTimeouts(hComm, &ctmoOld);
    CloseHandle(hComm);
  }

  s = ComboBox2->Items->Strings[ComboBox2->ItemIndex];

  hComm = CreateFile(s.c_str(), GENERIC_READ | GENERIC_WRITE, 0, 0, OPEN_EXISTING, 0, 0);
  if (hComm == INVALID_HANDLE_VALUE)
  {
    Button1->Enabled = false;
    hComm = NULL;
    return;
  }
  else
  {
    Button1->Enabled = true;
  }

  GetCommTimeouts(hComm,&ctmoOld);
  ctmoNew.ReadIntervalTimeout = MAXDWORD;
  ctmoNew.ReadTotalTimeoutConstant = 1000;
  ctmoNew.ReadTotalTimeoutMultiplier = 0;
  ctmoNew.WriteTotalTimeoutMultiplier = 0;
  ctmoNew.WriteTotalTimeoutConstant = 5000;
  SetCommTimeouts(hComm, &ctmoNew);

  s = ComboBox3->Items->Strings[ComboBox3->ItemIndex];

  dcbCommPort.DCBlength = sizeof(DCB);
  GetCommState(hComm, &dcbCommPort);
  BuildCommDCB(s.c_str(), &dcbCommPort);
  dcbCommPort.fAbortOnError = FALSE;
  SetCommState(hComm, &dcbCommPort);
  EscapeCommFunction(hComm, SETRTS);   //reset
  SetupComm(hComm, 2048, 2048);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  Button2->Enabled = false;
  Button3->Enabled = false;
  Button4->Enabled = false;

  if (reset() != 0)
  {
    ctmoNew.ReadTotalTimeoutConstant = 5000;
    SetCommTimeouts(hComm, &ctmoNew);

  //RSA 768 bit public and private exponentiation
    transmit_T_E(c_x10); receive_T_E(); rcode();
    transmit_T_E(c_x11); receive_T_E(); rcode();

    ctmoNew.ReadTotalTimeoutConstant = 1000;
    SetCommTimeouts(hComm, &ctmoNew);

  //AES encryption data & key
    transmit_T_E(c_x12); receive_T_E(); rcode();

  //random numbers
    transmit_T_E(c_x13); receive_T_E(); rcode();
    transmit_T_E(c_x14); receive_T_E(); rcode();
    transmit_T_E(c_x15); receive_T_E(); rcode();

  }

  Button2->Enabled = true;
  Button3->Enabled = true;
  Button4->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
  Button2->Enabled = false;
  Button3->Enabled = false;
  Button4->Enabled = false;

//change PIN old -> new
  transmit_T_E(c_x16); receive_T_E(); rcode();

//leave user code (application mode) and enter MAMP-OS upload mode upon valid PIN
  transmit_T_E(c_x17); receive_T_E(); rcode();
  transmit_T_E(c_x18); receive_T_E(); rcode();

  Button2->Enabled = true;
  Button3->Enabled = true;
  Button4->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{
  int rc;

  Button2->Enabled = false;
  Button3->Enabled = false;
  Button4->Enabled = false;

  reset();
  rc = upload(USER_EEPROM);	//upload eeprom first
  if (rc == 0)
  {
    reset();
    upload(USER_CODE);		//then code
  }

  Button2->Enabled = true;
  Button3->Enabled = true;
  Button4->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::rcode(void)
{
  s = "unknown rc";
  if ((r[5] == 0x90) && (r[6] == 0x00)) return;
  if ((r[5] == 0x6E) && (r[6] == 0x00)) s = "undefined class";
  if ((r[5] == 0x6D) && (r[6] == 0x00)) s = "undefined instruction";
  if ((r[5] == 0x6B) && (r[6] == 0x00)) s = "incorrect parameters REF1, REF2";
  if ((r[5] == 0x67) && (r[6] == 0x00)) s = "incorrect size LEN";
  if ((r[5] == 0x6A) && (r[6] == 0x87)) s = "inconsistent size LEN with REF1, REF2";
  if ((r[5] == 0x69) && (r[6] == 0x85)) s = "command not available";
  if ((r[5] == 0x6A) && (r[6] == 0x80)) s = "inconsistent data field";
  if ((r[5] == 0x62) && (r[6] == 0x00)) s = "checksum verification failed";
  if ((r[5] == 0x64) && (r[6] == 0x00)) s = "*** invalid REF1 ***";

  if (r[0] == 0x00) s = "no answer";
  Form1->Memo1->Lines->Add(s);
}
//---------------------------------------------------------------------------
int __fastcall TForm1::upload(int where)
{
  int len, i, b, rc = 1;


  if (where == USER_CODE)
    hFile = CreateFile("user.hex", GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);
  else
    hFile = CreateFile("useree.hex", GENERIC_READ, 0, 0, OPEN_EXISTING, 0, 0);

  if (hFile == INVALID_HANDLE_VALUE)
  {
    Form1->Memo1->Lines->Add("file not found");
    return(rc);
  }

  do
  {
    for (i = 0; i < MAX_ERASE; i++) r1[i] = 0;
    i = 0;
    do
    {
      ReadFile(hFile, r1 + i, 1, &rlen, NULL);
      if (rlen != 1) break;
      i++;
    }
    while (r1[i - 1] != 0x0A);

    if (r1[0] != ':') break;

    sscanf(r1 + 1, "%2x", &len);

    command[0] = 0x80;
    command[1] = 0xB0;
    command[3] = 0x00;
    command[4] = 0x00;
    command[5] = len + 4;

    if (where == USER_CODE)
      command[2] = 0x02; //user code
    else
      command[2] = 0x03; //user eeprom

    for (i = 0; i < (len + 4); i++)
    {
      sscanf(r1 + 3 + i*2, "%2x", &b);
      command[i + 6] = b;
    }

    transmit_T_E(command); receive_T_E(); rcode();

    rc = 0;
  }
  while (rlen == 1);

  CloseHandle(hFile);

  return(rc);
}
//---------------------------------------------------------------------------
