;This include file is part of MAMP-OS SDK

.equ	ADR_system_call	=	$010000

.equ	_sc_code_upload	=	0	;user code upload mode (9600 baud @ 3.57 MHz)
.equ	_sc_read_eeprom	=	1	;read from eeprom
.equ	_sc_write_eeprom	=	2	;write to eeprom
.equ	_sc_rx_byte	=	3	;receive one byte
.equ	_sc_tx_byte	=	4	;transmit one byte

.equ	_sc_RSA_modulus	=	5	;set RSA modulus
.equ	_sc_RSA_exponent	=	6	;set RSA exponent and calculate
.equ	_sc_RSA_data_in	=	7	;set RSA data
.equ	_sc_RSA_data_out	=	8	;get RSA data

.equ	_sc_AES_encrypt	=	9	;AES encryption
.equ	_sc_AES_decrypt	=	10	;AES decryption

.equ	_sc_DES_encrypt	=	11	;DES / 3DES encryption
.equ	_sc_DES_decrypt	=	12	;DES / 3DES decryption

.equ	_sc_random16	=	13	;get 16 nondeterministic random bytes
.equ	_sc_unique16	=	14	;get 16 nondeterministic unique bytes

.equ	_sc_header_T_0	=	15	;receive header (T=0 protocol)
.equ	_sc_ack_T_0	=	16	;transmit INS (T=0 protocol)
.equ	_sc_rx_T_0	=	17	;receive data (T=0 protocol)
.equ	_sc_tx_T_0	=	18	;transmit data (T=0 protocol)
.equ	_sc_RC_T_0	=	19	;transmit return code (T=0 protocol)

.equ	_sc_rx_T_E	=	20	;receive request (T=E protocol)
.equ	_sc_tx_T_E	=	21	;transmit answer (T=E protocol)

.equ	_sc_sleep	=	22	;idle or power down mode
.equ	_sc_SW_reset	=	23	;perform SW reset

.equ	_sc_rd_RC_high	=	24
.equ	_sc_rd_RC_low	=	25
.equ	_sc_wr_RC_high	=	26
.equ	_sc_wr_RC_low	=	27
.equ	_sc_byte_format	=	28
.equ	_sc_clock_baud	=	29
.equ	_sc_system_call	=	30

.equ	_sc_T_E_lead	=	31
.equ	_sc_T_E_chk	=	32

.equ	_sc_sleep_mode	=	33

.equ	_baud_9600_1000	=	$00	; 9600 baud @ 1.000 MHz
.equ	_baud_9600_2000	=	$01	; 9600 baud @ 2.000 MHz
.equ	_baud_9600_3000	=	$02	; 9600 baud @ 3.000 MHz
.equ	_baud_9600_3579	=	$03	; 9600 baud @ 3.579 MHz
.equ	_baud_9600_4000	=	$04	; 9600 baud @ 4.000 MHz
.equ	_baud_9600_4915	=	$05	; 9600 baud @ 4.915 MHz
.equ	_baud_9600_6000	=	$06	; 9600 baud @ 6.000 MHz

.equ	_baud_19200_2000	=	$11	;19200 baud @ 2.000 MHz
.equ	_baud_19200_3000	=	$12	;19200 baud @ 3.000 MHz
.equ	_baud_19200_3579	=	$13	;19200 baud @ 3.579 MHz
.equ	_baud_19200_4000	=	$14	;19200 baud @ 4.000 MHz
.equ	_baud_19200_4915	=	$15	;19200 baud @ 4.915 MHz
.equ	_baud_19200_6000	=	$16	;19200 baud @ 6.000 MHz

.equ	_baud_38400_3579	=	$23	;38400 baud @ 3.579 MHz
.equ	_baud_38400_4000	=	$24	;38400 baud @ 4.000 MHz
.equ	_baud_38400_4915	=	$25	;38400 baud @ 4.915 MHz

.equ	_baud_57600_4915	=	$35	;57600 baud @ 4.915 MHz

.equ	_last_parity	=	$01	;last received / transmitted parity bit
.equ	_parity_enable	=	$02	;0: no parity,    1: even/odd parity
.equ	_parity_even_odd	=	$04	;0: even parity,  1: odd parity
.equ	_convention	=	$80	;0: direct conv., 1: inverse convention

.equ	_RSA_512_length	=	$40
.equ	_RSA_768_length	=	$60
.equ	_RSA_1024_length	=	$80

.equ	_EC_RSA_success	=	0x01	;success
.equ	_EC_RSA_mod	=	0x02	;error in modulus
.equ	_EC_RSA_exp	=	0x03	;error in exponent
.equ	_EC_RSA_data	=	0x04	;error in data
.equ	_EC_RSA_length	=	0xFF	;length is not $40 / $60 / $80

.equ	_SLEEP_idle	=	$01
.equ	_SLEEP_power_down	=	$02

.equ	RAM_buf		=	$800	;$800-$BFF	1024 bytes user RAM
.equ	RAM_key		=	$BF0	;$BF0-$BFF	16 bytes AES key
					;$BF0-$BF7	8 bytes DES key or 3DES 1st key
					;$BF8-$BFF	8 bytes 3DES 2nd key

.equ	RC_9000		=	$9000	;command executed properly
.equ	RC_6E00		=	$6E00	;undefined class
.equ	RC_6D00		=	$6D00	;undefined instruction
.equ	RC_6B00		=	$6B00	;incorrect parameters REF1, REF2
.equ	RC_6985		=	$6985	;command not available
.equ	RC_6700		=	$6700	;incorrect size LEN
.equ	RC_6200		=	$6200	;checksum verification failed

.def	xl		=	r26
.def	xh		=	r27
.def	yl		=	r28
.def	yh		=	r29
.def	zl		=	r30
.def	zh		=	r31
